<script setup lang="ts">
import type { ProfilePictureMetaFrameSpecs } from '@/scripts/api-helper'
import { onMounted, reactive, ref, watch } from 'vue'

import frameOverlaySrc from '@/assets/frame_overlay.png'

const canvasBaseHeight = 800
const canvasBaseWidth = 800
const frameRatio = 40 / 34
const overlayHeightRatio = 0.9

const props = defineProps<{
  specs: ProfilePictureMetaFrameSpecs
  pictureUrl: string | null
  loading?: boolean
}>()

const emits = defineEmits<{
  crop: [value: ProfilePictureMetaFrameSpecs]
}>()

const frameOverlayImg = new Image()
frameOverlayImg.src = frameOverlaySrc
const croppingCanvas = ref<HTMLCanvasElement>()
const imageCanvas = ref<HTMLCanvasElement>()
const canvasContainer = ref<HTMLDivElement>()

const currentSpecs = defineModel<null | ProfilePictureMetaFrameSpecs>('currentSpecs', {
  default: null
})

const state = reactive({
  imageLoaded: false,
  slider: 100,
  spaceX: null as number | null,
  imageCanvasHeight: null as number | null,
  imageCanvasWidth: null as number | null,
  imageIsTall: null as boolean | null,
  frameX: null as number | null,
  frameY: null as number | null,
  frameHeight: null as number | null,
  frameWidth: null as number | null,
  canvasImg: new Image(),
  specs: null as ProfilePictureMetaFrameSpecs | null,
  /// used as a buffer when
  queuedSpecs: null as ProfilePictureMetaFrameSpecs | null,
  metadataInfo: ''
})

watch(
  () => props.pictureUrl,
  () => {
    updateImage()
  }
)

function updateImage() {
  if (!props.pictureUrl) {
    console.error('ImageCropper: no picture url')
    return
  }

  console.log(JSON.stringify(props))

  state.canvasImg.src = props.pictureUrl
  state.canvasImg.onload = updateImageCanvas
}

function updateImageCanvas() {
  console.log('updateImageCanvas called')
  if (!imageCanvas.value) {
    console.error('ImageCropper: canvas not ready')
    return
  }

  const canvas = imageCanvas.value
  const height = state.canvasImg.naturalHeight
  const width = state.canvasImg.naturalWidth
  const imageRatio = height / width
  state.imageIsTall = imageRatio >= frameRatio // frameRatio ~ 1,176

  if (state.imageIsTall!) {
    state.imageCanvasWidth = Math.round(canvas.height / imageRatio)
    state.imageCanvasHeight = canvas.height
    state.spaceX = Math.floor((canvas.width - state.imageCanvasWidth!) / 2)

    imageCanvas.value!.style.width = `${Math.round(state.imageCanvasHeight / 2)}px`
    croppingCanvas.value!.style.width = `${Math.round(state.imageCanvasHeight / 2)}px`
  } else {
    state.imageCanvasHeight = Math.round(canvas.width * imageRatio)
    state.spaceX = 0
    state.imageCanvasWidth = canvas.width

    // reduce the size of the div if the image is wide
    const cssHeight = `${Math.floor(state.imageCanvasHeight / 2)}px`
    canvasContainer.value!.style.height = cssHeight

    imageCanvas.value!.style.width = `${Math.round(state.imageCanvasWidth / 2)}px`
    croppingCanvas.value!.style.width = `${Math.round(state.imageCanvasWidth / 2)}px`
  }

  state.frameX = props.specs.ratio_x * state.imageCanvasWidth!
  state.frameY = props.specs.ratio_y * state.imageCanvasHeight!
  state.frameWidth = props.specs.ratio_w * state.imageCanvasWidth!
  state.frameHeight = props.specs.ratio_h * state.imageCanvasHeight!
  state.slider = props.specs.zoom

  const ctx = canvas.getContext('2d')
  if (ctx == null) {
    console.error('updateCroppingCanvas: unable to get context')
    return
  }
  ctx.drawImage(state.canvasImg, state.spaceX, 0, state.imageCanvasWidth, state.imageCanvasHeight)
  state.imageLoaded = true
  updateFrameSize()
}

function updateFrameSize() {
  if (state.imageIsTall) {
    state.frameWidth = Math.round((state.slider * state.imageCanvasWidth!) / 100)
    state.frameHeight = Math.round(state.frameWidth! * frameRatio)
  } else {
    state.frameHeight = Math.round((state.slider * state.imageCanvasHeight!) / 100)
    state.frameWidth = Math.round(state.frameHeight! / frameRatio)
  }
  updateFrame()
}

function canvasCursorUpdate(event: MouseEvent) {
  if (event.type !== 'click' && event.buttons !== 1) {
    return
  }
  console.log(event.offsetX * 2, event.offsetY * 2)
  updateFrameCenter(event.offsetX * 2, event.offsetY * 2)
}

function updateFrameCenter(x: number, y: number) {
  state.frameX = x - state.frameWidth! / 2 - state.spaceX!
  state.frameY = y - state.frameHeight! / 2
  updateFrame()
}

function updateFrame() {
  let x = state.frameX!
  let y = state.frameY!
  const w = state.frameWidth!
  const h = state.frameHeight!

  if (x < 0) {
    x = 0
    state.frameX = x
  } else if (x > state.imageCanvasWidth! - state.frameWidth!) {
    x = state.imageCanvasWidth! - state.frameWidth!
    state.frameX = x
  }

  if (y < 0) {
    y = 0
    state.frameY = y
  } else if (y > state.imageCanvasHeight! - state.frameHeight!) {
    y = state.imageCanvasHeight! - state.frameHeight!
    state.frameY = y
  }

  const specs: ProfilePictureMetaFrameSpecs = {
    ratio_x: state.frameX! / state.imageCanvasWidth!,
    ratio_y: state.frameY! / state.imageCanvasHeight!,
    ratio_w: state.frameWidth! / state.imageCanvasWidth!,
    ratio_h: state.frameHeight! / state.imageCanvasHeight!,
    zoom: state.slider
  }
  // console.log(
  //   state.frameX,
  //   state.frameY,
  //   state.frameWidth,
  //   state.frameHeight,
  //   state.imageCanvasWidth,
  //   state.imageCanvasHeight
  // )
  currentSpecs.value = specs
  const metaX = Math.round(specs.ratio_x * 100)
  const metaY = Math.round(specs.ratio_y * 100)
  const metaWidth = Math.round(specs.ratio_w * 100)
  const metaHeight = Math.round(specs.ratio_h * 100)
  const ratio =
    (specs.ratio_w * state.imageCanvasWidth!) / (specs.ratio_h * state.imageCanvasHeight!)
  state.metadataInfo = `${metaX}% ${metaY}% ${metaWidth}% ${metaHeight}%  ${ratio}`

  x += state.spaceX!

  if (!croppingCanvas.value) {
    return
  }
  const canvas = croppingCanvas.value
  const ctx = canvas.getContext('2d')
  if (ctx == null) {
    console.error('updateFrame: unable to get context')
    return
  }
  ctx.clearRect(0, 0, canvas.width, canvas.height)
  ctx.fillStyle = '#60000090'
  ctx.strokeStyle = '#fff'
  ctx.fillRect(state.spaceX!, 0, canvas.width - 2 * state.spaceX!, canvas.height)
  ctx.clearRect(x, y, w, h)
  ctx.strokeRect(x, y, w, h)

  const overlayHeight = h * overlayHeightRatio
  const overlayHeightDelta = overlayHeight - h
  ctx.drawImage(frameOverlayImg, x, y - overlayHeightDelta, w, overlayHeight)
}

function save() {
  if (!currentSpecs.value || props.loading) {
    return
  }
  emits('crop', currentSpecs.value)
}

onMounted(() => {
  updateImage()
})
</script>

<template>
  <div class="flex flex-col items-center space-y-3">
    <div ref="canvasContainer" class="relative overflow-hidden">
      <canvas class="m-auto" ref="imageCanvas" :width="canvasBaseWidth" :height="canvasBaseHeight"
        ><p>
          Canvas unavailable, if the current framing is incorrect you can report the issue using the
          button bellow
        </p></canvas
      >
      <canvas
        class="absolute top-0 left-1/2 -translate-x-1/2 m-auto"
        ref="croppingCanvas"
        :width="canvasBaseWidth"
        :height="canvasBaseHeight"
        @click="canvasCursorUpdate"
        @mousemove="canvasCursorUpdate"
      ></canvas>
    </div>
    <div class="mt-2 flex items-center space-x-3">
      <p class="text-gray-500 dark:text-gray-400">{{ $t('ui.zoom') }}</p>
      <input
        type="range"
        v-model.number="state.slider"
        class="w-full grow h-2 vertical bg-gray-200 rounded-lg appearance-none cursor-pointer dark:bg-gray-700"
        @input="updateFrameSize"
      />
      <AppButton @click="save" :loading="props.loading">{{ $t('ui.save') }}</AppButton>
    </div>
    <!-- <div class="mt-2">
      <p>
        {{ state.metadataInfo }}
      </p>
    </div> -->
  </div>
</template>
